#include "Command.hpp"
#include "StringUtils.hpp"

using std::string;

string Command::toString() const
{
    switch (m_action)
    {
    case Action::Halt:
        return "Halt";
    case Action::Wait:
        return "Wait";
    case Action::Flip:
        return "Flip";
    case Action::SMove:
        return "SMove " + m_coord1.toString();
    case Action::LMove:
        return "LMove " + m_coord1.toString() + " " + m_coord2.toString();
    case Action::FusionP:
        return "FusionP " + m_coord1.toString();
    case Action::FusionS:
        return "FusionS " + m_coord1.toString();
    case Action::Fission:
        return "Fission " + m_coord1.toString() + " " + strprintf("%" PRIu8 "", m_m);
    case Action::Fill:
        return "Fill " + m_coord1.toString();
    default:
        return "<unknown command>";
    }
}
