#ifndef COMMAND_HPP
#define COMMAND_HPP

#include "Common.hpp"
#include "Coord.hpp"

enum class Action : uint8_t
{
    Halt,
    Wait,
    Flip,
    SMove,
    LMove,
    FusionP,
    FusionS,
    Fission,
    Fill
};

class Command
{
public:
    Command() :
        m_action(Action::Halt),
        m_coord1(),
        m_coord2(),
        m_m(0) {}

    Command(Action action) :
        m_action(action),
        m_coord1(),
        m_coord2(),
        m_m(0) {}
    
    Command(Action action,
            const Coord& coord1) :
        m_action(action),
        m_coord1(coord1),
        m_coord2(),
        m_m(0) {}
    
    Command(Action action,
            const Coord& coord1,
            const Coord& coord2) :
        m_action(action),
        m_coord1(coord1),
        m_coord2(coord2),
        m_m(0) {}
    
    Command(Action action,
            const Coord& coord1,
            uint8_t m) :
        m_action(action),
        m_coord1(coord1),
        m_coord2(),
        m_m(m) {}
    
    std::string toString() const;

    Action m_action = Action::Halt;
    Coord m_coord1;
    Coord m_coord2;
    uint8_t m_m = 0;
};

#endif
