#include "Common.hpp"
#include "StringUtils.hpp"
#include "Model.hpp"
#include "Command.hpp"
#include "Trace.hpp"
#include "Sim.hpp"
#include "Check.hpp"
#include "Solve.hpp"

using std::string;
using std::vector;

int main(int argc, char *argv[])
{
    string msg;

#if 0
    for (uint32_t i = 1; i <= 186; i++)
    {
        string name = strprintf("../../../data/problemsL/LA%03" PRIu32 "_tgt.mdl", i);
        Model model;
        if (!model.load(name, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        uint32_t res = model.getRes();
        uint32_t filled = 0;
        uint32_t dense = 0;
        for (uint32_t x = 0; x < res; x++)
        {
            for (uint32_t y = 0; y < res; y++)
            {
                for (uint32_t z = 0; z < res; z++)
                {
                    filled += (model.get(x, y, z) != 0);
                    if (x + 2 < res && y + 2 < res && z + 2 < res)
                    {
                        uint32_t count = 0;
                        for (uint32_t dx = 0; dx < 3; dx++)
                        {
                            for (uint32_t dy = 0; dy < 3; dy++)
                            {
                                for (uint32_t dz = 0; dz < 3; dz++)
                                {
                                    count += (model.get(x + dx, y + dy, z + dz) != 0);
                                }
                            }
                        }
                        if (count == 27)
                        {
                            dense++;
                        }
                    }
                }
            }
        }

        uint64_t minEnergy =
            (uint64_t)(res * res * res * 3) *
            ((filled + (filled + 8) / 9) + 19) / 20;

        printf("%03" PRIu32": res %3" PRIu32 ", filled %7" PRIu32 ", dense %7" PRIu32 ", minEnergy %14" PRIu64 "\n",
               i,
               res,
               filled,
               dense,
               minEnergy);
    }
#endif

#if 0
    for (uint32_t i = 1; i <= 186; i++)
    {
        string name = strprintf("../../../data/dfltTracesL/LA%03" PRIu32 ".nbt", i);

        vector<uint8_t> data;
        if (!loadTraceData(name, &data, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        vector<Command> trace;
        if (!parseTrace(data, &trace, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        printf("%03" PRIu32": Trace size %" PRIuZ "\n", i, trace.size());

        string nameOut = strprintf("tmp/LA%03" PRIu32 ".nbt", i);

        vector<uint8_t> dataOut;
        if (!formatTrace(trace, &dataOut, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        /*
        if (!saveTraceData(dataOut, nameOut, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }
        */

        if (!std::equal(data.begin(), data.end(),
                        dataOut.begin(), dataOut.end()))
        {
            printf("%03" PRIu32": Not equal\n", i);
            continue;
        }
    }
#endif

#if 0
    for (uint32_t i = 1; i <= 186; i++)
    {
        string modelName = strprintf("../../../data/problemsL/LA%03" PRIu32 "_tgt.mdl", i);
        Model model;
        if (!model.load(modelName, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        string traceName = strprintf("../../../data/dfltTracesL/LA%03" PRIu32 ".nbt", i);
        vector<Command> trace;
        if (!loadTrace(traceName, &trace, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        Sim sim;
        sim.init(model.getRes());
        size_t pos = 0;
        bool bad = false;
        while (pos < trace.size())
        {
            if (sim.m_bots.empty())
            {
                printf("%03" PRIu32": Halted before end of trace\n", i);
                bad = true;
                break;
            }
            if (!sim.step(trace, pos, &msg))
            {
                printf("%03" PRIu32": %s\n", i, msg.c_str());
                bad = true;
                break;
            }
        }
        if (bad)
        {
            continue;
        }

        if (sim.m_model != model)
        {
            printf("%03" PRIu32": Models not equal\n", i);
            continue;
        }

        printf("%03" PRIu32": Energy = %" PRIu64 "\n", i, sim.m_energy);
    }
#endif

#if 1
    for (uint32_t i = 1; i <= 186; i++)
    {
        string modelName = strprintf("../../../data/problemsL/LA%03" PRIu32 "_tgt.mdl", i);
        Model model;
        if (!model.load(modelName, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        vector<Command> trace;
        solve(model, &trace);
        /*
        for (auto& command : trace)
        {
            printf("%s\n", command.toString().c_str());
        }
        */

        uint64_t energy = 0;
        if (!checkTrace(model, trace, &energy, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        printf("%03" PRIu32": energy = %" PRIu64 "\n", i, energy);
        string bestName = strprintf("../../../data/bestL/LA%03" PRIu32 ".nbt", i);
        if (!saveTrace(trace, bestName, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }
    }
#endif

#if 0
    {
        Model model(5);
        model.set(1, 0, 1, 1);
        model.set(1, 0, 2, 1);
        model.set(1, 0, 3, 1);
        model.set(2, 0, 1, 1);
        model.set(2, 0, 2, 1);
        model.set(2, 0, 3, 1);
        model.set(3, 0, 1, 1);
        model.set(3, 0, 2, 1);
        model.set(3, 0, 3, 1);
        model.set(1, 1, 1, 1);
        model.set(1, 1, 2, 1);
        model.set(1, 1, 3, 1);
        model.set(2, 1, 1, 1);
        model.set(2, 1, 2, 1);
        model.set(2, 1, 3, 1);
        model.set(3, 1, 1, 1);
        model.set(3, 1, 2, 1);
        model.set(3, 1, 3, 1);

        vector<Command> trace;
        solve(model, &trace);
    }
#endif

    return 0;
}
