#ifndef BATCH_HPP
#define BATCH_HPP

#include "Common.hpp"

enum class Batch : uint32_t
{
    LA,  // Lightning assemble
    FA,  // Full assemble
    FD,  // Full disassemble
    FR,  // Full reassemble
    FRD, // Full reassemble: disassemble portion
    FRA  // Full reassemble: assemble portion
};

bool parseBatch(const std::string& batchStr, Batch* pBatch);
std::string formatBatch(Batch batch);

#endif
