#include "Common.hpp"
#include "Mapping.hpp"
#include "Batch.hpp"

using std::string;
using std::vector;

int main(int argc, char *argv[])
{
    for (uint32_t pass = 0; pass < 2; pass++)
    {
        Batch batch = (pass == 0 ? Batch::FRD : Batch::FRA);
        vector<Mapping> mappings = getMappings(batch);

        for (uint32_t i = 1; i <= 115; i++)
        {
            auto& mapping = mappings[i - 1];
            bool self = (mapping.m_batch == batch) && (mapping.m_idx == i);
            bool sameBatch = (mapping.m_batch == batch);
            printf("%3s %03" PRIu32 ": %3s %03" PRIu32 "%s\n",
                   formatBatch(batch).c_str(),
                   i,
                   formatBatch(mapping.m_batch).c_str(),
                   mapping.m_idx,
                   self ? "  self" :
                   sameBatch ? "" /*"  same batch"*/ :
                   "");
        }

        printf("\n");
    }
}
