#include "Common.hpp"
#include "StringUtils.hpp"
#include "Model.hpp"
#include "Command.hpp"
#include "Trace.hpp"
#include "Sim.hpp"

using std::string;
using std::vector;

int main(int argc, char *argv[])
{
    string msg;

#if 0
    for (uint32_t i = 1; i <= 186; i++)
    {
        string name = strprintf("../../../data/problemsL/LA%03" PRIu32 "_tgt.mdl", i);
        Model model;
        if (!model.load(name, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        uint32_t res = model.getRes();
        uint32_t filled = 0;
        uint32_t dense = 0;
        for (uint32_t x = 0; x < res; x++)
        {
            for (uint32_t y = 0; y < res; y++)
            {
                for (uint32_t z = 0; z < res; z++)
                {
                    filled += (model.get(x, y, z) != 0);
                    if (x + 2 < res && y + 2 < res && z + 2 < res)
                    {
                        uint32_t count = 0;
                        for (uint32_t dx = 0; dx < 3; dx++)
                        {
                            for (uint32_t dy = 0; dy < 3; dy++)
                            {
                                for (uint32_t dz = 0; dz < 3; dz++)
                                {
                                    count += (model.get(x + dx, y + dy, z + dz) != 0);
                                }
                            }
                        }
                        if (count == 27)
                        {
                            dense++;
                        }
                    }
                }
            }
        }

        uint64_t minEnergy =
            (uint64_t)(res * res * res * 3) *
            ((filled + (filled + 8) / 9) + 19) / 20;

        printf("%03" PRIu32": res %3" PRIu32 ", filled %7" PRIu32 ", dense %7" PRIu32 ", minEnergy %14" PRIu64 "\n",
               i,
               res,
               filled,
               dense,
               minEnergy);
    }
#endif

#if 0
    for (uint32_t i = 1; i <= 115; i++)
    {
        string sourceName = strprintf("../../../data/problemsF/FR%03" PRIu32 "_src.mdl", i);
        string targetName = strprintf("../../../data/problemsF/FR%03" PRIu32 "_tgt.mdl", i);

        Model sourceModel;
        if (!sourceModel.load(sourceName, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        Model targetModel;
        if (!targetModel.load(targetName, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        uint32_t res = sourceModel.getRes();
        if (targetModel.getRes() != res)
        {
            printf("%03" PRIu32": Resolution mismatch\n", i);
            continue;
        }

        uint32_t sourceFilled = 0;
        uint32_t targetFilled = 0;
        uint32_t addCount = 0;
        uint32_t removeCount = 0;
        uint32_t keepCount = 0;
        for (uint32_t x = 0; x < res; x++)
        {
            for (uint32_t y = 0; y < res; y++)
            {
                for (uint32_t z = 0; z < res; z++)
                {
                    uint8_t curSourceFilled = sourceModel.get(x, y, z);
                    uint8_t curTargetFilled = targetModel.get(x, y, z);
                    if (curSourceFilled) sourceFilled++;
                    if (curTargetFilled) targetFilled++;
                    if (!curSourceFilled && curTargetFilled) addCount++;
                    if (curSourceFilled && !curTargetFilled) removeCount++;
                    if (curSourceFilled && curTargetFilled) keepCount++;
                }
            }
        }

        printf("%03" PRIu32"  res %3" PRIu32 "  src%8" PRIu32 "  tgt%8" PRIu32 "  add%8" PRIu32 "  rem%8" PRIu32 "  keep%8" PRIu32 "\n",
               i,
               res,
               sourceFilled,
               targetFilled,
               addCount,
               removeCount,
               keepCount);
    }
#endif

#if 0
    for (uint32_t i = 1; i <= 186; i++)
    {
        string name = strprintf("../../../data/dfltTracesL/LA%03" PRIu32 ".nbt", i);

        vector<uint8_t> data;
        if (!loadTraceData(name, &data, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        vector<Command> trace;
        if (!parseTrace(false, data, &trace, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        printf("%03" PRIu32": Trace size %" PRIuZ "\n", i, trace.size());

        string nameOut = strprintf("tmp/LA%03" PRIu32 ".nbt", i);

        vector<uint8_t> dataOut;
        if (!formatTrace(false, trace, &dataOut, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        /*
        if (!saveTraceData(dataOut, nameOut, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }
        */

        if (!std::equal(data.begin(), data.end(),
                        dataOut.begin(), dataOut.end()))
        {
            printf("%03" PRIu32": Not equal\n", i);
            continue;
        }
    }
#endif

#if 0
    for (uint32_t i = 1; i <= 186; i++)
    {
        string modelName = strprintf("../../../data/problemsL/LA%03" PRIu32 "_tgt.mdl", i);
        Model model;
        if (!model.load(modelName, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        string traceName = strprintf("../../../data/dfltTracesL/LA%03" PRIu32 ".nbt", i);
        vector<Command> trace;
        if (!loadTrace(false, traceName, &trace, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        Sim sim(false);
        sim.init(model.getRes());
        size_t pos = 0;
        bool bad = false;
        while (pos < trace.size())
        {
            if (sim.m_bots.empty())
            {
                printf("%03" PRIu32": Halted before end of trace\n", i);
                bad = true;
                break;
            }
            if (!sim.step(trace, pos, &msg))
            {
                printf("%03" PRIu32": %s\n", i, msg.c_str());
                bad = true;
                break;
            }
        }
        if (bad)
        {
            continue;
        }

        if (sim.m_model != model)
        {
            printf("%03" PRIu32": Models not equal\n", i);
            continue;
        }

        printf("%03" PRIu32": Energy = %" PRIu64 "\n", i, sim.m_energy);
    }
#endif

#if 0
    for (uint32_t i = 1; i <= 186; i++)
    {
        string targetModelName = strprintf("../../../data/problemsF/FA%03" PRIu32 "_tgt.mdl", i);
        Model targetModel;
        if (!targetModel.load(targetModelName, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        Model sourceModel(targetModel.getRes());

        string traceName = strprintf("../../../data/dfltTracesF/FA%03" PRIu32 ".nbt", i);
        vector<Command> trace;
        if (!loadTrace(true, traceName, &trace, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        Sim sim(true);
        sim.init(std::move(sourceModel));
        size_t pos = 0;
        bool bad = false;
        while (pos < trace.size())
        {
            if (sim.m_bots.empty())
            {
                printf("%03" PRIu32": Halted before end of trace\n", i);
                bad = true;
                break;
            }
            if (!sim.step(trace, pos, &msg))
            {
                printf("%03" PRIu32": %s\n", i, msg.c_str());
                bad = true;
                break;
            }
        }
        if (bad)
        {
            continue;
        }

        if (sim.m_model != targetModel)
        {
            printf("%03" PRIu32": Models not equal\n", i);
            continue;
        }

        printf("%03" PRIu32": Energy = %" PRIu64 "\n", i, sim.m_energy);
    }
#endif

#if 0
    for (uint32_t i = 1; i <= 186; i++)
    {
        string sourceModelName = strprintf("../../../data/problemsF/FD%03" PRIu32 "_src.mdl", i);
        Model sourceModel;
        if (!sourceModel.load(sourceModelName, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        Model targetModel(sourceModel.getRes());

        string traceName = strprintf("../../../data/dfltTracesF/FD%03" PRIu32 ".nbt", i);
        vector<Command> trace;
        if (!loadTrace(true, traceName, &trace, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        Sim sim(true);
        sim.init(std::move(sourceModel));
        size_t pos = 0;
        bool bad = false;
        while (pos < trace.size())
        {
            if (sim.m_bots.empty())
            {
                printf("%03" PRIu32": Halted before end of trace\n", i);
                bad = true;
                break;
            }
            if (!sim.step(trace, pos, &msg))
            {
                printf("%03" PRIu32": %s\n", i, msg.c_str());
                bad = true;
                break;
            }
        }
        if (bad)
        {
            continue;
        }

        if (sim.m_model != targetModel)
        {
            printf("%03" PRIu32": Models not equal\n", i);
            continue;
        }

        printf("%03" PRIu32": Energy = %" PRIu64 "\n", i, sim.m_energy);
    }
#endif

#if 0
    for (uint32_t i = 1; i <= 115; i++)
    {
        string sourceModelName = strprintf("../../../data/problemsF/FR%03" PRIu32 "_src.mdl", i);
        Model sourceModel;
        if (!sourceModel.load(sourceModelName, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        string targetModelName = strprintf("../../../data/problemsF/FR%03" PRIu32 "_tgt.mdl", i);
        Model targetModel;
        if (!targetModel.load(targetModelName, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        if (sourceModel.getRes() != targetModel.getRes())
        {
            printf("%03" PRIu32": Resolution mismatch\n", i);
            continue;
        }

        string traceName = strprintf("../../../data/dfltTracesF/FR%03" PRIu32 ".nbt", i);
        vector<Command> trace;
        if (!loadTrace(true, traceName, &trace, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        Sim sim(true);
        sim.init(std::move(sourceModel));
        size_t pos = 0;
        bool bad = false;
        while (pos < trace.size())
        {
            if (sim.m_bots.empty())
            {
                printf("%03" PRIu32": Halted before end of trace\n", i);
                bad = true;
                break;
            }
            if (!sim.step(trace, pos, &msg))
            {
                printf("%03" PRIu32": %s\n", i, msg.c_str());
                bad = true;
                break;
            }
        }
        if (bad)
        {
            continue;
        }

        if (sim.m_model != targetModel)
        {
            printf("%03" PRIu32": Models not equal\n", i);
            continue;
        }

        printf("%03" PRIu32": Energy = %" PRIu64 "\n", i, sim.m_energy);
    }
#endif

#if 0
    for (uint32_t i = 1; i <= 186; i++)
    {
        string traceNameL = strprintf("../../../data/bestL/LA%03" PRIu32 ".nbt", i);
        string traceNameF = strprintf("../../../data/bestF/FA%03" PRIu32 ".nbt", i);

        vector<uint8_t> data;
        if (!loadTraceData(traceNameL, &data, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        if (!saveTraceData(data, traceNameF, &msg))
        {
            printf("%03" PRIu32": %s\n", i, msg.c_str());
            continue;
        }

        printf("%03" PRIu32": done\n", i);
    }
#endif

    return 0;
}
